// Simple Water shader. (c) Victor Korsun, bitekas@gmail.com; 2012.
//
// Attribution-ShareAlike CC License.

// Water test file 1-a

#ifdef GL_ES
precision highp float;
#endif

uniform vec2 texSize;
uniform float tick;
uniform sampler2D tex;
uniform vec2 mapCoord;
uniform vec4 texCoord;

const float PI = 3.1415926535897932;

// play with these parameters to custimize the effect
// ===================================================

//speed
const float speed = 0.2;
const float speed_x = 0.3;
const float speed_y = 0.3;

// refraction
const float emboss = 0.50;
const float intensity = 2.4;
const int steps = 10;
const float frequency = 12.0;
const int angle = 7; // better when a prime

// reflection
const float delta = 60.;
const float intence = 700.;

const float reflectionCutOff = 0.012;
const float reflectionIntence = 200000.;

// ===================================================

float time = tick / 10000.0;

float col(vec2 coord)
{
	float col = 2.0 * PI / float(angle);
	return cos(col);
}

//---------- main

void main(void)
{
	gl_FragColor = vec4(vec3(0.1), 0.3 * col(vec2(0.5)));
}
