// Simple Water shader. (c) Victor Korsun, bitekas@gmail.com; 2012.
//
// Attribution-ShareAlike CC License.

// Water test file 2-c

#ifdef GL_ES
precision highp float;
#endif

uniform vec2 texSize;
uniform float tick;
uniform sampler2D tex;
uniform vec2 mapCoord;
uniform vec4 texCoord;

const float PI = 3.1415926535897932;

// play with these parameters to custimize the effect
// ===================================================

//speed
const float speed = 0.2;
const float speed_x = 0.3;
const float speed_y = 0.3;

// refraction
const float emboss = 0.50;
const float intensity = 2.4;
const int steps = 10;
const float frequency = 12.0;
const int angle = 7; // better when a prime

// reflection
const float delta = 60.;
const float intence = 700.;

const float reflectionCutOff = 0.012;
const float reflectionIntence = 200000.;

// ===================================================

float time = tick / 10000.0;

float col(vec2 coord)
{
	float col = 0.5;
	return col;
}

//---------- main

void main(void)
{
	vec2 p = (vec2(mapCoord.x, texSize.y - mapCoord.y)) / texSize.xy, c1 = p, c2 = p;
	float cc1 = col(c1);

	c2.x += texSize.x/delta;
	float dx = emboss*(cc1-col(c2))/delta;

	c2.x = p.x;
	c2.y += texSize.y/delta;
	float dy = emboss*(cc1-col(c2))/delta;

	c1.x += dx*2.;
	c1.y = -(c1.y+dy*2.);

	float alpha = 1.+dot(dx,dy)*intence;
		
	float ddx = dx - reflectionCutOff;
	float ddy = dy - reflectionCutOff;
	if (ddx > 0. && ddy > 0.)
		alpha = pow(alpha, ddx*ddy*reflectionIntence);
	
	c1 = clamp(c1, texCoord.xy, texCoord.xy + texCoord.zw);
	vec4 col = texture2D(tex, texCoord.xy + c1 * texCoord.zw)*(alpha);
	gl_FragColor = col;
}
